#ifndef BACKPORT_LINUX_NAMEI_H
#define BACKPORT_LINUX_NAMEI_H

#include_next <linux/namei.h>
#include <linux/audit.h>
#include <linux/path.h>

static inline int vfs_path_lookup(struct dentry *dentry, struct vfsmount *mnt,
		    const char *name, unsigned int flags,
		    struct nameidata *nd)
{
	int retval;

	/* same as do_path_lookup */
	nd->last_type = LAST_ROOT;
	nd->flags = flags;
	nd->depth = 0;

	nd->dentry = dentry;
	nd->mnt = mnt;
	backport_path_get(nd);

	retval = path_walk(name, nd);
	if (unlikely(!retval && !audit_dummy_context() && nd->dentry &&
				nd->dentry->d_inode))
		audit_inode(name, nd->dentry->d_inode);

	return retval;
}
#endif /* BACKPORT_LINUX_NAMEI_H */
